<?php
defined('B_PROLOG_INCLUDED') || die;
use Bitrix\Main\Page\Asset;
use Bitrix\Main\EventManager;
use \Bitrix\Sale\Delivery\Services\Manager as DeliveryManager;

global $APPLICATION;
$module_id = 'dellindev.delivery';


CModule::AddAutoloadClasses(
    $module_id,
    array(
        "DellinAPI" => "classes/general/DellinAPI.php",
        "DellinDelivery" => "classes/general/DellinDelivery.php",
        "ApiCore" => "classes/general/ApiCore.php"
    )
);




if (strpos($APPLICATION->GetCurPage(),'/bitrix/admin/dellin_orders.php') !== false) {
    CJSCore::RegisterExt(
        'dellinDeliveryAdmin',
        array(
            'js'=> '/bitrix/js/'.$module_id.'/dellinDeliveryAdmin.js',
            'css'=>array('/bitrix/css/'.$module_id.'/dellinDeliveryAdmin.css'),
            'rel'=>array('jquery')
        )
    );
    CJSCore::Init('dellinDeliveryAdmin');

    $asset = Asset::getInstance();
    $asset->addString('
        <script>
            BX.ready(function() {
                BX.dellinDeliveryAdmin.init();
            });
        </script>'
    );
}
if(strpos($APPLICATION->GetCurPage(),'/bitrix/admin/sale_delivery_service_edit.php') !== false){
    CJSCore::RegisterExt(
        'dellinDeliverySettings',
        array(
            'js'=> '/bitrix/js/'.$module_id.'/dellinDeliverySettings.js',
            'css'=>array('/bitrix/css/'.$module_id.'/dellinDeliverySettings.css'),
            'rel'=>array('jquery')
        )
    );
    CJSCore::Init('dellinDeliverySettings');

    $asset = Asset::getInstance();
    $asset->addString('
        <script>
            BX.ready(function() {
                BX.dellinDeliverySettings.init();
            });
        </script>'
    );
}

$pathToOrder = "/personal/order/make";

if(strpos($APPLICATION->GetCurPage(),$pathToOrder) !== false){

    $deliveries = DeliveryManager::GetActiveList();
    foreach($deliveries as $delivery){
        if($delivery["CODE"] == "dellindev.delivery"){
            $config = unserialize(unserialize($delivery['CONFIG']['MAIN']['OLD_SETTINGS']));
            if($config['API_KEY']){
              $apiKey = $config['API_KEY'];
              break;
            }

        }
    }

    //DellinDelivery::UpdateOpf($apiKey);

    CJSCore::RegisterExt(
        'dellinDeliveryCheckout',
        array(
            'js'=> '/bitrix/js/'.$module_id.'/dellinDeliveryCheckout.js',
            'css'=>array('/bitrix/css/'.$module_id.'/dellinDeliveryCheckout.css'),
            'rel'=>array('jquery')
        )
    );
    CJSCore::Init('dellinDeliveryCheckout');

    $asset = Asset::getInstance();
    $asset->addString('
        <script>
            BX.ready(function() {
                BX.dellinDeliveryCheckout.init();
            });
        </script>'
    );
}