<?php
use Bitrix\Main\Loader;
use \Bitrix\Sale\Delivery\Services\Manager as DeliveryManager;

require_once($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/main/include/prolog_before.php");
Loader::includeModule('sale');
Loader::includeModule('dellindev.delivery');;
$deliveryId = $_REQUEST['DELIVERY_ID'];
if($_REQUEST['SELECTED_PROFILE_ID']){
    $delivery = DeliveryManager::GetByID($_REQUEST['SELECTED_PROFILE_ID']);
    $deliveryId = $delivery['PARENT_ID'];
}
$config = DellinDelivery::GetDeliveryConfig($deliveryId);
if($_REQUEST['ACTION'] == "SEARCH_STREET"){
    $request = trim($_REQUEST['query']);
    if($_REQUEST['KLADR']){
        $kladr = trim($_REQUEST['KLADR']);
    }elseif($_REQUEST['BX_LOCATION_ID']){
        $kladr = DellinAPI::GetCityKLADRCode($_REQUEST['BX_LOCATION_ID'],$_REQUEST['ALT_LOCATION_NAME']);
    }

    $arParams = array(
     "appkey"    => ($_REQUEST['API_KEY']!=="")?$_REQUEST['API_KEY']:$config['API_KEY']['VALUE'],
     "code"      => $kladr,
     "street"    => $request,
     "limit"     => $_REQUEST['COUNT']?:2
    );
    $sessionID = DellinAPI::GetDellinSessionId($config);
    if($sessionID){
        $arParams["sessionID"] = $sessionID;
    }
    $streets = ApiCore::GetStreetKladr($arParams);
    $result = $streets['streets'];
    echo json_encode($result,JSON_UNESCAPED_UNICODE);
}

if($_REQUEST['ACTION'] == "GET_TERMINALS"){
    if($_REQUEST['MODE'] == "REQUEST_TERMINALS" ){//все терминалы доступные по направлению
        $arTerminalIdValues['']="Терминал не выбран";
        if($_REQUEST['KLADR']){
            $data = array(
                "appkey" =>$_REQUEST['API_KEY'],
                "code" => $_REQUEST['KLADR'],
                "direction" => "derival"
            );
            $terminalsOb = ApiCore::sendApiRequest('requestTerminal',$data);
            $terminalsInfo = ApiCore::GetTerminals($_REQUEST['API_KEY']);
            foreach ($terminalsOb->terminals as $terminal) {
                if($terminalsInfo[$terminal->city_code]['terminals'][$terminal->id]->receiveCargo){ //если терминал может принять товар
                    $arTerminalIdValues[$terminal->id] = $terminal->address;
                }
            }
        }
    }else{
        /*echo "<pre>";
        var_dump($_SESSION['current_terminals']);
        echo "</pre>";*/
        if($_SESSION['current_terminals']){ //это терминалы, которые подходят именно для текущего заказа в корзине, они записываются из метода Calculate
            foreach ($_SESSION['current_terminals'] as $terminal){
                $arTerminalIdValues[$terminal->id] = $terminal->address;
            }
        }
        $db_ptype = CSalePersonType::GetList(Array("SORT" => "ASC"), Array("LID"=>SITE_ID));
        if($db_ptype->nSelectedCount == 1){
            $person_type_id = $db_ptype->fetch()['ID'];
        }else{
            $person_type_id = $_REQUEST['PERSON_TYPE_ID'];
        }
        $db_props = CSaleOrderProps::GetList(
            array("SORT" => "ASC"),
            array(
                "PERSON_TYPE_ID" => $person_type_id,
                "CODE"=>array("TERMINAL_ID","TERMINAL_ADDRESS")
            ),
            false,
            false,
            array('ID','CODE')
        );
        while($prop = $db_props->Fetch()){
            $props[$prop['CODE']] = $prop['ID'];
        }
        $result['PROPS'] = $props;
    }


    $result['TERMINALS'] = $arTerminalIdValues;
    echo json_encode($result,JSON_UNESCAPED_UNICODE);
}

if($_REQUEST['ACTION'] == "SEARCH_CITY"){

    $cityData = array(
        "appkey" => ($_REQUEST['API_KEY'] !== "")?$_REQUEST['API_KEY']:$config['API_KEY']['VALUE'],
        "q"      => $_REQUEST['query'],
        "limit"  => $_REQUEST['COUNT']
    );
    $cities = ApiCore::sendApiRequest('cityInfo',$cityData);
    $result = $cities->cities;
    echo json_encode($result,JSON_UNESCAPED_UNICODE);
}

if(isset($_REQUEST['PERSON_TYPE_ID'])){
    $ar_ptype = CSalePersonType::GetByID($_REQUEST['PERSON_TYPE_ID']);
    $person_type_name = $ar_ptype['NAME'];
}else{
    $db_ptype = CSalePersonType::GetList(Array("SORT" => "ASC"), Array("LID"=>SITE_ID));
    if($db_ptype->nSelectedCount == 1) {
        $person_type_id = $db_ptype->fetch()['ID'];
        $person_type_name = $db_ptype->fetch()['NAME'];

    }
}

if($_REQUEST['ACTION'] == "GET_LOCATION_INPUTS_IDS"){
    $altLocationPropId = CSaleOrderProps::GetList(array(),array('TYPE'=>'LOCATION','PERSON_TYPE_ID'=>$_REQUEST['PERSON_TYPE_ID']),false,false,array())->Fetch()['INPUT_FIELD_LOCATION'];
    $altLocationPropCode = CSaleOrderProps::GetByID($altLocationPropId)['CODE'];
    $db_props = CSaleOrderProps::GetList(
        array("SORT" => "ASC"),
        array(
            "PERSON_TYPE_ID" => $person_type_id,
            "CODE"=>array("JURIDICAL_STREET", "JURIDICAL_STREET_KLADR", "LOCATION", "STREET", "STREET_KLADR","JURIDICAL_CITY","JURIDICAL_CITY_KLADR","JURIDICAL_OPF_COUNTRY","JURIDICAL_OPF",$altLocationPropCode)
        ),
        false,
        false,
        array()
    );
    $result = array('STATUS'=>"OK");
    while ($prop = $db_props->Fetch()) {
        if(mb_stripos($person_type_name,'юридическ') !== false){
            if($prop['CODE'] == "JURIDICAL_STREET"){
                $result['JURIDICAL_STREET_ID'] = $prop['ID'];
            }
            if($prop['CODE'] == "JURIDICAL_STREET_KLADR" && $prop['ID']){
                $result['JURIDICAL_STREET_KLADR_ID'] = $prop['ID'];
            }
            if($prop['CODE'] == "JURIDICAL_CITY" && $prop['ID']){
                $result['JURIDICAL_CITY_ID'] = $prop['ID'];
            }
            if($prop['CODE'] == "JURIDICAL_CITY_KLADR" && $prop['ID']){
                $result['JURIDICAL_CITY_KLADR_ID'] = $prop['ID'];
            }
            if($prop['CODE'] == "JURIDICAL_OPF_COUNTRY" && $prop['ID']){
                $result['JURIDICAL_OPF_COUNTRY_ID'] = $prop['ID'];
            }
            if($prop['CODE'] == "JURIDICAL_OPF" && $prop['ID']){
                $result['JURIDICAL_OPF_ID'] = $prop['ID'];
            }

        }
        if($prop['CODE'] == "LOCATION") {
            $result['LOCATION_INPUT_ID'] = $prop['ID'];
        }
        if($prop['CODE'] == "STREET"){
            $result['STREET_INPUT_ID'] = $prop['ID'];
        }
        if($prop['CODE'] == "STREET_KLADR"){
            $result['STREET_KLADR_ID'] = $prop['ID'];
        }
        if($prop['CODE'] == $altLocationPropCode){
            $result['ALT_LOCATION_INPUT_ID'] = $prop['ID'];
        }
    }
    foreach ($result as $code => $props){
        if(!$props){
            $result['STATUS'] = 'ERROR';
            $result['TEXT'] .= 'Не найдено свойство с кодом: "'.$code.'. Создайте его в свойствах заказа. "';
        }
    }
    echo json_encode($result,JSON_UNESCAPED_UNICODE );
}

if($_REQUEST['ACTION'] == 'GET_COUNTERAGENTS'){
    $config['LOGIN']['VALUE'] = trim($_REQUEST['LOGIN']);
    $config['PASSWORD']['VALUE'] = trim($_REQUEST['PASSWORD']);
    $config['API_KEY']['VALUE'] = trim($_REQUEST['API_KEY']);
    if($_REQUEST['MODE'] == 'settings_change'){
        $config['RESET_SESSION'] = true;
    }
    $sessionID = DellinAPI::GetDellinSessionId($config);
    $arCounterAgents = array('' => 'Контрагент не выбран');
    if($sessionID !== Null) {
        $counterAgents = ApiCore::sendApiRequest('requestCounteragents',array('appkey' => $config['API_KEY']['VALUE'], 'sessionID' => $sessionID, "full_info" => true));
        if(!$counterAgents->errors) {
            $counterAgents = $counterAgents->counteragents;
            foreach ($counterAgents as $counterAgent) {
                if ($counterAgent->uid) {
                    $arCounterAgents[$counterAgent->uid] = $counterAgent->name;
                }
            }
        }
    }
    echo json_encode(array('counteragents'=>$arCounterAgents,'sessionID'=>$sessionID),JSON_UNESCAPED_UNICODE);
}

if($_REQUEST['ACTION'] == "UPDATE_OPF"){
    if(isset($_REQUEST['SELECTED_PROFILE_ID'])){
        $_REQUEST['API_KEY'] = $config['API_KEY']['VALUE'];
    }
    $arOpf = DellinDelivery::GetOpf();
    echo json_encode($arOpf,JSON_UNESCAPED_UNICODE);
}

//Специальная функция, которая возвращает id свойств заказа для выбранного метода доставки.
if($_REQUEST['ACTION'] == "GET_FIELDS_ID"){
    $db_ptype = CSalePersonType::GetList(Array("SORT" => "ASC"), Array("LID"=>SITE_ID));
    if($db_ptype->nSelectedCount == 1){
        $person_type_id = $db_ptype->fetch()['ID'];
    }else{
        $person_type_id = $_REQUEST['PERSON_TYPE_ID'];
    }
    //если у нас выбрана доставка "до адреса", обязательно необходимы поля "удобное время получения", поэтому они и возвращаются ниже.
    if($config['IS_GOODS_UNLOADING']['VALUE'] == "Y"){
        $additionalProps= CSaleOrderProps::GetList(array(),array('PERSON_TYPE_ID'=>$person_type_id,'CODE'=>array('DELLIN_DELIVERYTIME_START','DELLIN_DELIVERYTIME_END')),false,false,array());
        while($prop = $additionalProps->fetch()){
            $additionalPropIds[$prop['CODE']] = $prop['ID'];
        }
    }
    echo json_encode($additionalPropIds,JSON_UNESCAPED_UNICODE);
}