<?php
IncludeModuleLangFile(__FILE__);

class dellindev_delivery extends CModule
{
	var $MODULE_ID = "dellindev.delivery";
    var $MODULE_VERSION;
    var $MODULE_VERSION_DATE;
    var $MODULE_NAME;
    var $MODULE_DESCRIPTION;
    var $PARTNER_NAME;
    var $PARTNER_URI;
    var $MODULE_GROUP_RIGHTS = "N";
    var $NEED_MAIN_VERSION = "";
    var $NEED_MODULES = array("sale");

	function dellindev_delivery()
    {
		$arModuleVersion = array();

		$path = str_replace("\\", "/", __FILE__);
		$path = substr($path, 0, strlen($path) - strlen("/index.php"));
		include($path . "/version.php");

        $this->MODULE_VERSION = $arModuleVersion["VERSION"];
        $this->MODULE_VERSION_DATE = $arModuleVersion["VERSION_DATE"];

        $this->MODULE_NAME = GetMessage("DELLIN_MODULE_NAME");
        $this->MODULE_DESCRIPTION = GetMessage("DELLIN_MODULE_DESCRIPTION");

		$this->PARTNER_NAME = GetMessage("DELLIN_PARTNER_NAME");
		$this->PARTNER_URI = "https://www.dellin.ru/";
	}

    function InstallEvents()
    {

        RegisterModuleDependences("sale", "onSaleDeliveryHandlersBuildList", $this->MODULE_ID, "DellinDelivery", "Init",false,false,array('ADDITIONAL_PARAMETERS'=>array('1'=>'first')));
        return true;
    }

    function AddOrderProperties(){
	    //свойства для обоих типов плательщика
	    $arrPropertiesAllPersonType = array(
	        array('NAME'=>'удобное время получения (начало)','CODE'=>'DELLIN_DELIVERYTIME_START'),
            array('NAME'=>'удобное время получения (конец)','CODE'=>'DELLIN_DELIVERYTIME_END'),
            array('NAME'=>'Терминал','CODE'=>'TERMINAL_ID'),
            array('NAME'=>'Адрес терминала','CODE'=>'TERMINAL_ADDRESS'),
            array('NAME'=>'Улица','CODE'=>'STREET'),
            array('NAME'=>'КЛАДР улицы','CODE'=>'STREET_KLADR'),
            array('NAME'=>'Дом','CODE'=>'HOUSE_NUM'),
            array('NAME'=>'Квартира/офис','CODE'=>'FLAT_NUM'),
        );
        if (CModule::IncludeModule("sale")) {
            $resPersonTypes = CSalePersonType::GetList(array(), array());
            for($n = 0;$n<=24;$n++){
                if($n == 24){
                    $arTimeValues[]= "23:59";
                }else{
                    $arTimeValues[]= (($n<10)?"0":"").$n.":00";
                }

            }
            while ($personType = $resPersonTypes->Fetch()) {
                foreach($arrPropertiesAllPersonType as $arProperty){
                    $arFields = array(
                        "PERSON_TYPE_ID" => $personType['ID'],
                        "NAME" => $arProperty['NAME'],
                        "TYPE" => (strpos($arProperty['CODE'],'DELIVERYTIME') !== false)?"SELECT":"STRING",
                        "REQUIRED" => "N",
                        "DEFAULT_VALUE" => "",
                        "SORT" => 100,
                        "CODE" => $arProperty['CODE'],
                        "USER_PROPS" => "N",
                        "IS_LOCATION" => "N",
                        "IS_LOCATION4TAX" => "N",
                        "PROPS_GROUP_ID" => 1,
                        "SIZE1" => 0,
                        "SIZE2" => 0,
                        "DESCRIPTION" => "",
                        "IS_EMAIL" => "N",
                        "IS_PROFILE_NAME" => "N",
                        "IS_PAYER" => "N"
                    );
                    $resOrder = CSaleOrderProps::GetList(array(),array('CODE'=>$arProperty['CODE'],'PERSON_TYPE_ID'=>$personType['ID']));
                    $ID = $resOrder->Fetch()['ID'];
                    if ($resOrder->nSelectedCount > 0)
                    {
                        if (!CSaleOrderProps::Update($ID, $arFields))
                        {
                            echo GetMessage('PROPERTY_UPDATE_ERROR');
                        }
                        else
                        {
                            // Обновим символьный код у значений свойства
                            // (хранение избыточных данных для оптимизации работы)
                            $db_order_props_tmp =
                                CSaleOrderPropsValue::GetList(($b="NAME"),
                                    ($o="ASC"),
                                    Array("ORDER_PROPS_ID"=>$ID));
                            while ($ar_order_props_tmp = $db_order_props_tmp->Fetch())
                            {
                                CSaleOrderPropsValue::Update($ar_order_props_tmp["ID"],
                                    array("CODE" => $arProperty['CODE']));
                            }
                        }
                    }
                    else
                    {
                        $ID = CSaleOrderProps::Add($arFields);
                        if ($ID<=0) {
                            echo GetMessage('PROPERTY_CREATE_ERROR');
                        }else{
                            echo "Свойство добавлено: ".$arProperty['NAME'];
                        }
                    }
                    if(strpos($arProperty['CODE'],'DELIVERYTIME') !== false){
                        CSaleOrderPropsVariant::DeleteAll($ID);
                        foreach($arTimeValues as $index=>$timeValue){
                            $arFieldsV = array(
                                "ORDER_PROPS_ID" => $ID,
                                "VALUE" => $timeValue,
                                "NAME" => $timeValue,
                                "SORT" => $index,
                                "DESCRIPTION" =>""
                            );
                            if (!CSaleOrderPropsVariant::Add($arFieldsV)) echo "Ошибка добавления варианта значения".$arProperty['CODE'];
                        }
                    }
                }
            }
            //свойства только для юридических лиц
            $arrPropertiesJuridicalPersonType = array(
                array('NAME'=>'Юридический адрес: Страна','CODE'=>'JURIDICAL_OPF_COUNTRY'),
                array('NAME'=>'Юридический адрес: ОПФ','CODE'=>'JURIDICAL_OPF'),
                array('NAME'=>'Юридический адрес: Город','CODE'=>'JURIDICAL_CITY'),
                array('NAME'=>'Юридический адрес: Кладр города','CODE'=>'JURIDICAL_CITY_KLADR'),
                array('NAME'=>'Юридический адрес: Улица','CODE'=>'JURIDICAL_STREET'),
                array('NAME'=>'Юридический адрес: Кладр улицы','CODE'=>'JURIDICAL_STREET_KLADR'),
                array('NAME'=>'Юридический адрес: Дом','CODE'=>'JURIDICAL_HOUSE_NUM'),
                array('NAME'=>'Юридический адрес: Строение','CODE'=>'JURIDICAL_BUILDING_NUM'),
                array('NAME'=>'Юридический адрес: Корпус','CODE'=>'JURIDICAL_STRUCTURE_NUM'),
                array('NAME'=>'Юридический адрес: Квартира/офис','CODE'=>'JURIDICAL_FLAT_NUM')
            );
            foreach($arrPropertiesJuridicalPersonType as $arProperty){
                $arFields = array(
                    "PERSON_TYPE_ID" => 2,
                    "NAME" => $arProperty['NAME'],
                    "TYPE" => "STRING",
                    "REQUIRED" => "N",
                    "DEFAULT_VALUE" => "",
                    "SORT" => 100,
                    "CODE" => $arProperty['CODE'],
                    "USER_PROPS" => "N",
                    "IS_LOCATION" => "N",
                    "IS_LOCATION4TAX" => "N",
                    "PROPS_GROUP_ID" => 1,
                    "SIZE1" => 0,
                    "SIZE2" => 0,
                    "DESCRIPTION" => "",
                    "IS_EMAIL" => "N",
                    "IS_PROFILE_NAME" => "N",
                    "IS_PAYER" => "N"
                );
                $resOrder = CSaleOrderProps::GetList(array(),array('CODE'=>$arProperty['CODE']));
                $ID = $resOrder->Fetch()['ID'];

                if ($resOrder->nSelectedCount > 0)
                {
                    if (!CSaleOrderProps::Update($ID, $arFields))
                    {
                        echo GetMessage('PROPERTY_UPDATE_ERROR');
                    }
                    else
                    {
                        // Обновим символьный код у значений свойства
                        // (хранение избыточных данных для оптимизации работы)
                        $db_order_props_tmp =
                            CSaleOrderPropsValue::GetList(($b="NAME"),
                                ($o="ASC"),
                                Array("ORDER_PROPS_ID"=>$ID));
                        while ($ar_order_props_tmp = $db_order_props_tmp->Fetch())
                        {
                            CSaleOrderPropsValue::Update($ar_order_props_tmp["ID"],
                                array("CODE" => $arProperty['CODE']));
                        }
                    }
                }
                else
                {
                    $ID = CSaleOrderProps::Add($arFields);
                    if ($ID<=0)
                        echo GetMessage('PROPERTY_CREATE_ERROR');
                }
            }
        }
        return true;
    }

    function UnInstallEvents()
    {
        UnRegisterModuleDependences("sale", "onSaleDeliveryHandlersBuildList", $this->MODULE_ID, "DellinDelivery", "Init");
        CAgent::RemoveModuleAgents($this->MODULE_ID);

        return true;
    }

    function InstallFiles()
    {
        CopyDirFiles($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/dellindev.delivery/install/components",
            $_SERVER["DOCUMENT_ROOT"]."/bitrix/components/", true, true);
        CopyDirFiles($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/dellindev.delivery/install/js/",
            $_SERVER["DOCUMENT_ROOT"]."/bitrix/js/", true, true);
        CopyDirFiles($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/dellindev.delivery/install/css/",
            $_SERVER["DOCUMENT_ROOT"]."/bitrix/css/", true, true);
        CopyDirFiles($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/dellindev.delivery/install/css/",
            $_SERVER["DOCUMENT_ROOT"]."/bitrix/css/", true, true);
        CopyDirFiles($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/dellindev.delivery/install/include/dellin_ajax.php",
            $_SERVER["DOCUMENT_ROOT"]."/bitrix/tools/dellindev.delivery/dellin_ajax.php", true, true);
        CopyDirFiles($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/dellindev.delivery/install/admin/dellin_orders.php",
            $_SERVER["DOCUMENT_ROOT"]."/bitrix/admin/dellin_orders.php", true, true);
        return true;
    }

    function UnInstallFiles()
    {
        DeleteDirFilesEx($_SERVER["DOCUMENT_ROOT"]."/bitrix/components/dellindev.delivery");
        DeleteDirFilesEx($_SERVER["DOCUMENT_ROOT"]."/bitrix/js/dellindev.delivery");
        DeleteDirFilesEx($_SERVER["DOCUMENT_ROOT"]."/bitrix/css/dellindev.delivery");
        DeleteDirFilesEx($_SERVER["DOCUMENT_ROOT"]."/bitrix/admin/dellin_ajax.php");
        DeleteDirFilesEx($_SERVER["DOCUMENT_ROOT"]."/bitrix/admin/dellin_orders.php");
        return true;
    }

	function DoInstall()
    {
        $this->InstallFiles();
        $this->InstallEvents();
        $this->AddOrderProperties();
        RegisterModule($this->MODULE_ID);
	}

	function DoUninstall()
    {
        $this->UnInstallFiles();
        $this->UnInstallEvents();
        UnRegisterModule($this->MODULE_ID);
	}
}
