var dellinDeliverySettings = BX.namespace('dellinDeliverySettings');


dellinDeliverySettings.init = function(){

    var login = $('[name="CONFIG[dellin_delivery_settings][LOGIN]"]').val();
    var password = $('[name="CONFIG[dellin_delivery_settings][PASSWORD]"]').val();
    var apikey = $('[name="CONFIG[dellin_delivery_settings][API_KEY]"]').val();
    var kladr = $('[name="CONFIG[dellin_delivery_settings][KLADR_CODE_DELIVERY_FROM]"]').val();
    dellinDeliverySettings.getCounteragents(login,password,apikey);
    dellinDeliverySettings.getRequestTerminalsDerival(kladr,apikey);

    $('[name="CONFIG[dellin_delivery_settings][COUNTERAGENT]"]').attr('readonly','readonly');
    $('[name="CONFIG[dellin_delivery_settings][TERMINAL_ID]"]').attr('readonly','readonly');
    $('[name="CONFIG[dellin_delivery_settings][OPF_COUNTRY]"]').attr('readonly','readonly');
    $('[name="CONFIG[dellin_delivery_settings][SENDER_FORM]"]').attr('readonly','readonly');
    $('[name = "CONFIG[dellin_delivery_settings][SENDER_JURIDICAL_KLADR_STREET]"]').attr('data_city_kladr_input_name','SENDER_JURIDICAL_KLADR_CITY');
    var streetInputs = $('[name = "CONFIG[dellin_delivery_settings][LOADING_ADDRESS]"],[name = "CONFIG[dellin_delivery_settings][SENDER_JURIDICAL_KLADR_STREET]"]');
    $( "<input class='findStreetKladr' type='Button' value='найти КЛАДР улицы'>" ).insertAfter( $(streetInputs) );
    var cityInputs = $('[name = "CONFIG[dellin_delivery_settings][KLADR_CODE_DELIVERY_FROM]"],[name = "CONFIG[dellin_delivery_settings][SENDER_JURIDICAL_KLADR_CITY]"]');
    $( "<input class='findCityKladr' type='Button' value='найти КЛАДР города'>" ).insertAfter( $(cityInputs) );
    $.each( $('.findStreetKladr'),function(index,element){
        var apikey = $('[name="CONFIG[dellin_delivery_settings][API_KEY]"]').val();
        dellinDeliverySettings.findKladdrEventInit( $(element), "SEARCH_STREET", 5);
    });

    dellinDeliverySettings.findKladdrEventInit( $('.findCityKladr'), "SEARCH_CITY", 10);
    dellinDeliverySettings.updateOpf(apikey);



    $('[name="CONFIG[dellin_delivery_settings][LOGIN]"],[name="CONFIG[dellin_delivery_settings][PASSWORD]"],[name="CONFIG[dellin_delivery_settings][API_KEY]"]').change(function(){
        login = $('[name="CONFIG[dellin_delivery_settings][LOGIN]"]').val();
        password = $('[name="CONFIG[dellin_delivery_settings][PASSWORD]"]').val();
        apikey = $('[name="CONFIG[dellin_delivery_settings][API_KEY]"]').val();

        dellinDeliverySettings.getCounteragents(login,password,apikey,'settings_change');
        if($(this).attr('name') == 'CONFIG[dellin_delivery_settings][API_KEY]'){
            dellinDeliverySettings.updateOpf(apikey);
        }
    });

    $('[name="CONFIG[dellin_delivery_settings][KLADR_CODE_DELIVERY_FROM]"]').change(function(){
        var kladr = $(this).val();
        apikey = $('[name="CONFIG[dellin_delivery_settings][API_KEY]"]').val();
        dellinDeliverySettings.getRequestTerminalsDerival(kladr,apikey);
    });
    dellinDeliverySettings.requiredFields();
    $(document).click(function(e){
        if(!$(e.target).hasClass('autocomplete-row')){
            $('.autocomplete').remove();
        }
    });
}

//TO-DO: проверка заполнения обязательных полей
dellinDeliverySettings.requiredFields = function(){
    /*var requiredFields = [
        'API_KEY',
        'REQUEST_EMAIL',
        'KLADR_CODE_DELIVERY_FROM',
        'SENDER_FORM',
        'SENDER_NAME',
        'SENDER_INN',
        'SENDER_CONTACT_PERSON_NAME',
        'SENDER_CONTACT_PHONE',
        'SENDER_CONTACT_EMAIL',
        'SENDER_JURIDICAL_KLADR_STREET',
        'SENDER_JURIDICAL_KLADR_HOUSE'
    ]
    $.each(requiredFields,function(){
       $('[name="CONFIG[dellin_delivery_settings]['+this+']"]').attr('required','required');
    });*/
}

dellinDeliverySettings.updateOpf = function(apikey){
    $.ajax({
        url: "/bitrix/tools/dellindev.delivery/dellin_ajax.php",
        data: {'AJAX':'Y','ACTION':'UPDATE_OPF','API_KEY':apikey},
        method: "GET",
        dataType: "json"
    }).done(function(response){
        if( $('[name="CONFIG[dellin_delivery_settings][OPF_COUNTRY]"]').val() == "" || $('[name="CONFIG[dellin_delivery_settings][OPF_COUNTRY]"]').val() == "NULL"){
            $('[name="CONFIG[dellin_delivery_settings][OPF_COUNTRY]"]').val('0x8f51001438c4d49511dbd774581edb7a');
        }
        if($('#opf_country').length > 0){
            $('#opf_country').replaceWith('<select id="opf_country"></select>');
        }else{
            $('<select id="opf_country"></select>').insertBefore($('[name="CONFIG[dellin_delivery_settings][OPF_COUNTRY]"]'));
        }

        var options = "";
        $.each(response.countries,function(id,name){
            var selected = '';
            if(id == $('[name="CONFIG[dellin_delivery_settings][OPF_COUNTRY]"]').val()){
                selected = "selected";
            }
            options += '<option '+selected+' value="'+id+'">'+name+'</option>>';
        });
        $('select#opf_country').html(options);
        $('select#opf_country').change(function(){
            $('[name="CONFIG[dellin_delivery_settings][OPF_COUNTRY]"]').val($(this).val());
            dellinDeliverySettings.updateOpf(apikey);//обновляем опф
        });

        if( $('[name="CONFIG[dellin_delivery_settings][SENDER_FORM]"]').val() == "" || $('[name="CONFIG[dellin_delivery_settings][SENDER_FORM]"]').val() == "NULL"){
            $('[name="CONFIG[dellin_delivery_settings][SENDER_FORM]"]').val('0x92ee03691f25a9fe4be9910cd87ca9ca');
        }
        var opfList = response.opf[$('[name="CONFIG[dellin_delivery_settings][OPF_COUNTRY]"]').val()];
        if($('#opf').length > 0){
            $('#opf').replaceWith('<select id="opf"></select>');
        }else{
            $('<select id="opf"></select>').insertBefore($('[name="CONFIG[dellin_delivery_settings][SENDER_FORM]"]'));
        }

        if($(opfList).length > 0){
            options = "";
            $.each(opfList,function(id,name){
                var selected = '';
                if(id == $('[name="CONFIG[dellin_delivery_settings][SENDER_FORM]"]').val()){
                    selected = "selected";
                }
                options += '<option '+selected+' value="'+id+'">'+name+'</option>>';
            });
            $('select#opf').html(options);
            $('select#opf').change(function(){
                $('[name="CONFIG[dellin_delivery_settings][SENDER_FORM]"]').val($(this).val());
            });
        }
    });
};

dellinDeliverySettings.setKladr = function(element){
    $(element).closest('td').find('input[type=text]').first().val($(element).siblings('input[type=text]').attr('kladr'));
    $(element).closest('td').find('input[type=text]').first().trigger('change');
    $(element).closest('.popup-container').remove();
}

dellinDeliverySettings.removeThisPopup = function(element){
    $(element).closest('.popup-container').remove();
}

dellinDeliverySettings.setAutoCompleteKladr = function (element) {
    $(element).closest('.autocomplete').siblings('input[type=text]').val($(element).html()).attr('kladr',$(element).attr('data-id'));
    $(element).closest('.autocomplete').remove();
}

dellinDeliverySettings.getCounteragents = function(login,password,apikey,flag=false){
    dellinDeliverySettings.showLoading();
    var data =  {'AJAX':'Y','ACTION':'GET_COUNTERAGENTS','LOGIN':login,'PASSWORD':password, 'API_KEY':apikey, 'DELIVERY_ID':dellinDeliverySettings.getUrlParameter('ID')};
    if(flag !== false){
        data.MODE = flag;
    }
    $.ajax({
        url: "/bitrix/tools/dellindev.delivery/dellin_ajax.php",
        data: data,
        method: "GET",
        dataType: "json"
    }).done(function(response){
        console.log(response);
        if(response.errors !== false){
            console.log(response.errors);
        }
        var select = '<select id="counteragnets">';
        $.each(response.counteragents,function(id,value){
            var selected = '';
            if(id == $('[name="CONFIG[dellin_delivery_settings][COUNTERAGENT]"]').val()){
                selected = "selected";
            }
            select +='<option '+selected+' value="'+id+'">'+value+'</option>';
        });
        select += "</select>";
        if($('#counteragnets').length > 0){
            $('#counteragnets').replaceWith(select);
        }else{
            $(select).insertBefore($('[name="CONFIG[dellin_delivery_settings][COUNTERAGENT]"]'));
        }
        $('[name="CONFIG[dellin_delivery_settings][COUNTERAGENT]"]').val($('#counteragnets').val());
        $('#counteragnets').change(function(){
            $('[name="CONFIG[dellin_delivery_settings][COUNTERAGENT]"]').val($(this).val());
        });
        dellinDeliverySettings.hideLoading();

        //$('[name="CONFIG[dellin_delivery_settings][COUNTERAGENT]"]').html(options);
    });
}

dellinDeliverySettings.getRequestTerminalsDerival = function(kladr,apikey){
    dellinDeliverySettings.showLoading();
    $.ajax({
        url: "/bitrix/tools/dellindev.delivery/dellin_ajax.php",
        data: {'AJAX':'Y','ACTION':'GET_TERMINALS','MODE':'REQUEST_TERMINALS','KLADR':kladr, 'API_KEY':apikey,  'DELIVERY_ID':dellinDeliverySettings.getUrlParameter('ID')},
        method: "GET",
        dataType: "json"
    }).done(function(response){
        var select = '<select id="requestTerminals">';
        $.each(response.TERMINALS,function(id,value){
            var selected = '';
            if(id == $('[name="CONFIG[dellin_delivery_settings][TERMINAL_ID]"]').val()){
                selected = "selected";
            }
            select +='<option '+selected+' value="'+id+'">'+value+'</option>';
        });
        select += "</select>";
        if($('#requestTerminals').length > 0){
            $('#requestTerminals').replaceWith(select);
        }else{
            $(select).insertBefore($('[name="CONFIG[dellin_delivery_settings][TERMINAL_ID]"]'));
        }
        $('[name="CONFIG[dellin_delivery_settings][TERMINAL_ID]"]').val($('#requestTerminals').val());
        $('#requestTerminals').change(function(){
            $('[name="CONFIG[dellin_delivery_settings][TERMINAL_ID]"]').val($(this).val());
        });
        dellinDeliverySettings.hideLoading();
        //$('[name="CONFIG[dellin_delivery_settings][COUNTERAGENT]"]').html(options);
    });
}

dellinDeliverySettings.findKladdrEventInit = function(element,ajaxAction,limit){
    $(element).click(function(){
        var cityKladr;
        if($(element).siblings('input[type=text]').attr('data_city_kladr_input_name') !== undefined && $.trim($('[name = "CONFIG[dellin_delivery_settings]['+$(element).siblings('input[type=text]').attr('data_city_kladr_input_name')+']"]').val()).length>0){
            cityKladr = $('[name = "CONFIG[dellin_delivery_settings]['+$(element).siblings('input[type=text]').attr('data_city_kladr_input_name')+']"]').val();
        }else{
            cityKladr = $('[name = "CONFIG[dellin_delivery_settings][KLADR_CODE_DELIVERY_FROM]"]').val();
        }
        var error = "";
        var inputDisabled = "";
        if(ajaxAction == "SEARCH_STREET" && cityKladr == undefined && $(element).siblings('input[type="text"]').attr('data_city_kladr_input_name') !== undefined){
            error = "Не задан КЛАДР города";
            inputDisabled = "disabled";
        }
        var apikey = $('[name="CONFIG[dellin_delivery_settings][API_KEY]"]').val();
        var msg = 'Начните писать название';
        if(apikey.length <= 0){
            msg += '<br/><span class="error">Для поиска должен быть заполнен Ключ API</span>';
        }
        if($(element).siblings('input').attr('name')=="CONFIG[dellin_delivery_settings][SENDER_JURIDICAL_KLADR_STREET]" && (!$('[name="CONFIG[dellin_delivery_settings][SENDER_JURIDICAL_KLADR_CITY]"]').val() && !$('[name="CONFIG[dellin_delivery_settings][KLADR_CODE_DELIVERY_FROM]"]').val())){
            msg += '<br/><span class="error">Для поиска должен быть заполнен Код КЛАДР города / Пункта отправления</span>';
        }else if($(element).siblings('input').attr('name')=="CONFIG[dellin_delivery_settings][LOADING_ADDRESS]" && !$('[name="CONFIG[dellin_delivery_settings][KLADR_CODE_DELIVERY_FROM]"]').val()){
            msg += '<br/><span class="error">Для поиска должен быть заполнен Пункт отправления</span>';
        }
        $('<div class="kladrDiv popup-container">' +
            '<span>'+msg+'</span></br>'+
            '<input type="text" name="query" class="kladr_autocomplete"'+inputDisabled+' value="'+error+'">' +
            '&nbsp;<input type="button" class="setKladr" value="выбрать" onclick="dellinDeliverySettings.setKladr(this)"><input type="button" class="close" value="Закрыть" onclick="dellinDeliverySettings.removeThisPopup(this)">' +
            '').insertAfter($(this));
        $('.kladr_autocomplete').bind('keyup',function(){
            var input = this;
            var apikey = $('[name="CONFIG[dellin_delivery_settings][API_KEY]"]').val();
            if($(this).val().length >= 2){
                $.ajax({
                    url: "/bitrix/tools/dellindev.delivery/dellin_ajax.php",
                    data: {'AJAX':'Y','ACTION':ajaxAction,'query':$(this).val(),'COUNT':limit, 'KLADR':cityKladr,'API_KEY':apikey, 'DELIVERY_ID':dellinDeliverySettings.getUrlParameter('ID')},
                    method: "GET",
                    dataType: "json"
                }).done(function(response){
                    console.log(response);
                    if(response.STATUS !== "ERROR"){
                        $(input).siblings('.autocomplete').remove();

                        $('<div class="autocomplete"><div class="rows"></div></div>').insertAfter($(input));
                        if(response.STATUS == "ERROR"){
                            $(input).siblings('.autocomplete').find('.rows').append('<div class="autocomplete-row" onclick="dellinDeliverySettings.setAutoCompleteKladr(this)">'+response.BODY+' </div>')
                        }else{
                            $.each(response,function(index,el){

                                $(input).siblings('.autocomplete').find('.rows').append('<div class="autocomplete-row" onclick="dellinDeliverySettings.setAutoCompleteKladr(this)" data-id="'+el.code+'">'+el.aString+' ['+el.code+']</div>')
                            });
                        }
                    }
                })
            }else{
                $(input).siblings('.autocomplete').remove();
            }
        })
    });
}
dellinDeliverySettings.getUrlParameter = function(name){
    name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
    var regex = new RegExp('[\\?&]' + name + '=([^&#]*)');
    var results = regex.exec(location.search);
    return results === null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
};
dellinDeliverySettings.showLoading = function(){
    dellinDeliverySettings.hideLoading();
    $('#edit_dellin_delivery_settings').append('<div class="loading-wrap"></div>');
    $('#edit_dellin_delivery_settings').append('<div class="loading"><span class="loading-content"><img src="/bitrix/js/main/core/images/wait.gif"> Обработка запроса...</span></div>');
}
dellinDeliverySettings.hideLoading = function(){
    $('.loading-wrap').remove();
    $('.loading').remove();
}